opal/mca/maffinity/maffinity.h File Reference.TH "opal/mca/maffinity/maffinity.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
opal/mca/maffinity/maffinity.h \- maffinity (memory affinity) framework component interface definitions. 
.SH SYNOPSIS
.br
.PP
\fC#include 'ompi_config.h'\fP
.br
\fC#include 'opal/mca/mca.h'\fP
.br
\fC#include 'opal/mca/base/base.h'\fP
.br
\fC#include 'opal/mca/maffinity/maffinity_types.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBOPAL_MAFFINITY_BASE_VERSION_1_0_0\fP"
.br
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef const struct \fBopal_maffinity_base_module_1_0_0_t\fP *(* \fBopal_maffinity_base_component_query_1_0_0_fn_t\fP )(int *priority)"
.br
.RI "\fIQuery function for maffinity components. \fP"
.ti -1c
.RI "typedef int(* \fBopal_maffinity_base_module_init_1_0_0_fn_t\fP )(void)"
.br
.RI "\fIModule initialization function. \fP"
.ti -1c
.RI "typedef int(* \fBopal_maffinity_base_module_set_fn_t\fP )(\fBopal_maffinity_base_segment_t\fP *segments, size_t num_segments)"
.br
.RI "\fIModule function to set memory affinity. \fP"
.ti -1c
.RI "typedef \fBopal_maffinity_base_component_1_0_0_t\fP \fBopal_maffinity_base_component_1_0_0_t\fP"
.br
.RI "\fIConvenience typedef. \fP"
.ti -1c
.RI "typedef \fBopal_maffinity_base_module_1_0_0_t\fP \fBopal_maffinity_base_module_1_0_0_t\fP"
.br
.RI "\fIConvenience typedef. \fP"
.in -1c
.SH "Detailed Description"
.PP 
maffinity (memory affinity) framework component interface definitions. 

Intent
.PP
Simple component to set memory affinity for pages. Note that this framework assumes that processor affinity is being used (it doesn't make much sense to use memory affinity unless processes are bound to specific processors, otherwise the processes may move around and the memory may end up being remote).
.PP
maffinity components are typically used with shared memory operations, but can be used elsewhere as well. The idea is to get memory physically located with the process that is going to use it. For memory allocated to a processor-bound process, functions such as malloc() do this naturally. However, when working with memory shared by multiple processes on a NUMA machine, it can be extremely advantageous to ensure that pages containing the data structures for a given process are physically local to the processor where that process is bound.
.PP
One process will allocate a large shared memory block and all will need to participate to make pages local to specific processors.
.PP
There is one main module function (opal_maffinity_base_module_set_fn_t) that takes an array of segment descriptions within the block. Each process will get a different set of segment descriptions (i.e., the segments belonging to that process). Components then do whatever is necessary to make pages local to their respective processes (i.e., the processors where the processes are running).
.SH "Define Documentation"
.PP 
.SS "#define OPAL_MAFFINITY_BASE_VERSION_1_0_0"
.PP
\fBValue:\fP
.PP
.nf
/* maffinity v1.0 is chained to MCA v1.0 */ \
    MCA_BASE_VERSION_1_0_0, \
    /* maffinity v1.0 */ \
    'maffinity', 1, 0, 0
.fi
.SH "Typedef Documentation"
.PP 
.SS "typedef const struct \fBopal_maffinity_base_module_1_0_0_t\fP*(* \fBopal_maffinity_base_component_query_1_0_0_fn_t\fP)(int *priority)"
.PP
Query function for maffinity components. 
.PP
Simply returns a priority to rank it against other available maffinity components (assumedly, only one component will be available per platform, but it's possible that there could be more than one available). 
.SS "typedef int(* \fBopal_maffinity_base_module_init_1_0_0_fn_t\fP)(void)"
.PP
Module initialization function. 
.PP
Should return OPAL_SUCCESS. 
.SS "typedef int(* \fBopal_maffinity_base_module_set_fn_t\fP)(\fBopal_maffinity_base_segment_t\fP *segments, size_t num_segments)"
.PP
Module function to set memory affinity. 
.PP
Take an array of maffinity_base_segment_t instances to describe which memory should physically reside with which process.
.PP
This function is intended to be invoked by each process immediately after they mmap / attach the shared memory. In some cases, it will be a no-op for some processes (i.e., machines where a single function call in the creating process sets the memory affinity for the entire region), but in other cases all processes will need to participate (e.g., the first_use component, each each process will 'touch' the pages that are supposed to be local to them). 
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
